/*! node-ati 2023-04-26 */
var _=require("lodash"),fs=require("fs"),Timeline=require("./timeline.js"),Datafile=require("./../lib/utils/datafile.js"),log4js=require("log4js"),_log=log4js.getLogger("model.timelines");function Timelines(e,i){var t;this._items=[],this._dataFileName="./data/timelines.json",(this._cachedJson=void 0)!==e&&("object"==typeof e&&"function"==typeof e.getItems&&(e=e.getItems()),t=this,_.forEach(e,function(e){t.add(new Timeline(e))}))}Timelines.prototype.add=function(e){var i;!_.some(this._items)||null!=e._id&&0!=e._id?null!=e._id&&0!=e._id||(e._id=1):(i=0<this._items.length?_.maxBy(this._items,"_id")._id:0,e._id=0<i?i+1:1),this._items.push(e)},Timelines.prototype.findById=function(i){return _.find(this._items,function(e){return e._id==i})},Timelines.prototype.removeById=function(i){_.remove(this._items,function(e){return e._id==i})},Timelines.prototype.getRawData=function(){var e=_.cloneDeep(_.filter(this._items,function(e){return-1!==_.parseInt(e._id)}),!0);return _.map(e,function(e){return e.spots=_.map(e.spots,function(e){return _.parseInt(e._id)}),e.spotAddresses=void 0,e.nodes=_.map(e.nodes,function(e){return(e=_.cloneDeep(e,!0)).color=e.color._id,e.parent=void 0,e}),e})},Timelines.prototype.save=function(){var e=this.getRawData();this._cachedJson=void 0,_log.info("invalidate cached json data while saving..."),Datafile.writeData(e,this._dataFileName)},Timelines.prototype.getItems=function(){return this._items},Timelines.prototype.getCachedJsonString=function(){return void 0===this._cachedJson&&(_log.info("create cached json data"),this._cachedJson=JSON.stringify(this.getItems())),this._cachedJson},Timelines.prototype.load=function(){var e=Datafile.readData(this._dataFileName);if(void 0!==e){_log.info("invalidate cached json data while loading..."),this._cachedJson=void 0,this._items=[];for(var i=0;i<e.length;i++)this._items.push(new Timeline(e[i]))}},Timelines.prototype.setSpots=function(e,i){this._updateSpots(e,i)},Timelines.prototype.setColors=function(e){this._updateColors(e)},Timelines.prototype.resetPreviousValues=function(){_.forEach(this._items,function(e){e=e.getAllChannels();_.forEach(e,function(e){e.previousValue=0})})},Timelines.prototype._updateColors=function(i){_.forEach(this._items,function(e){e.updateColors(i)})},Timelines.prototype._updateSpots=function(i,t){var e,n=this,s=(_.forEach(this._items,function(e){e.updateSpots(i,t)}),_.uniq(_.flatten(_.map(_.filter(this._items,function(e){return-1!==e._id}),function(e){return _.map(e.spots,"_id")})))),o=_.filter(i.getItems(),function(e){return-1===_.indexOf(s,e._id)&&!0===e.enabled}),a=[];_.forEach(o,function(i){var e=_.find(n._items,function(e){return void 0!==_.find(e.spots,function(e){return(e.isLocal()||i.isLocal())&&e.name===i.name})});(void 0!==e?e.spots:1===n._items.length?n._items[0].spots:a).push(i)}),_.some(a)&&(void 0===(e=this.findById(-1))&&((e=new Timeline)._id=-1,e.name="UNASSIGNED",this.add(e)),e.spots=o),_.forEach(this._items,function(e){void 0!==e.inputValue||_.some(e.spots)||(e.active=!1)})},Timelines.prototype.Initialized=function(){return void 0===this._initialized&&(this._initialized=fs.existsSync(this._dataFileName)),this._initialized},Timelines.prototype.updateNode=function(e,i,t,n,s){var e=this.findById(e);e&&(e=e.nodes[i])&&(e.time=void 0!==t?t:e.time,e.value=void 0!==n?n:e.value,e.color=void 0!==s?s:e.color)},Timelines.prototype.mergeBackupFile=function(e,i,t,n){var s=this,o=0;if(i)for(var a,r=0;r<this._items.length;r++)void 0!==t&&!_.includes(t,this._items[r]._id)||(a={nodes:_.cloneDeep(e.timelines[0].nodes,!0)},this._items[r].update(a),this._items[r].presetting=n);else for(var d=e.timelines,r=0;r<d.length;r++){var m,l=d[r];void 0===l||l.disabled||-1===l._id||!1===l.colorEditable||(m=_.find(s._items,function(e){return e.name===l.name}),l._id=void 0,(l.spots=void 0)!==m?(m.update(l),m.presetting=void 0,n&&(m.presetting=n)):(l.name=s._items[0].name,s._items[0].update(l),s._items[0].presetting=void 0,n&&(s._items[0].presetting=n)),o++)}_log.info("load "+o+" timelines from a backup file")},Timelines.prototype.getMaxIntensity=function(){for(var e=0,i=0;i<this._items.length;i++){var t=this._items[i].getMaxIntensity();e<t&&(e=t)}return e},Timelines.prototype.setIntensity=function(i,t){var n=this.getMaxIntensity();_.forEach(this._items,function(e){void 0!==t&&!_.includes(t,e._id)||e.setIntensity(i,n)})},Timelines.prototype.setTimeRange=function(i,t,n){var s=this.getTimeRange();_.forEach(this._items,function(e){void 0!==n&&!_.includes(n,e._id)||e.setTimeRange(i,t,s.start,s.end)})},Timelines.prototype.getTimeRange=function(i,e,t){var n=86400,s=0;return _.forEach(this._items,function(e){return-1===e._id||(!(!0!==i||void 0!==e.spots&&_.some(e.spots,function(e){return void 0!==e.isLocal&&e.isLocal()}))||((e=e.getTimeRange()).start<n&&(n=e.start),void(e.end>s&&(s=e.end))))}),void 0!==e&&((n+=e)<0?n=86400+n:86400<n&&(n-=86400)),{start:this._transformTimestamp(n,e),end:this._transformTimestamp(s,t)}},Timelines.prototype._transformTimestamp=function(e,i){return void 0!==i&&(e+=i),e<0?e=86400+e:86400<e&&(e-=86400),e},Timelines.prototype.groupToOneTimeline=function(){var i=new Timeline(_.cloneDeep(this._items[0]));i.spots=[],i.name="GROUP_NAME_SEC",_.each(this._items,function(e){_.each(e.spots,function(e){i.spots.push(_.cloneDeep(e))})}),this._items=[],this._items.push(i)},Timelines.prototype.getDownloadData=function(){var i=[];return _.each(this._items,function(e){_.some(e.spots)&&((e=_.cloneDeep(e)).spots=_.map(e.spots,function(e){return e._id}),e.nodes=_.map(e.nodes,function(e){return{time:Math.round(e.time),value:e.value,type:e.type,index:e.index,color:{_id:e.color._id,name:e.color.name}}}),e.$$hashKey=void 0,i.push(e))}),i},module.exports=Timelines;